Attribute VB_Name = "mDiskVolume"
'This Module createtd by Sosed213 
'Version 1.0
'18:06 13.04.2012

Option Explicit

Public Type LARGE_INTEGER
    LowPart As Long
    HighPart As Long
End Type

'//file system
'Public Declare Function CreateFile Lib "kernel32" Alias "CreateFileA" (ByVal lpFileName As String, ByVal dwDesiredAccess As Long, ByVal dwShareMode As Long, lpSecurityAttributes As Long, ByVal dwCreationDisposition As Long, ByVal dwFlagsAndAttributes As Long, ByVal hTemplateFile As Long) As Long
'Public Declare Function CloseHandle Lib "kernel32" (ByVal hObject As Long) As Long
Public Declare Function ReadFile Lib "kernel32" (ByVal hFile As Long, lpBuffer As Any, ByVal nNumberOfBytesToRead As Long, lpNumberOfBytesRead As Long, ByVal lpOverlapped As Long) As Long '//declare has changed
Public Declare Function WriteFile Lib "kernel32" (ByVal hFile As Long, lpBuffer As Any, ByVal nNumberOfBytesToWrite As Long, lpNumberOfBytesWritten As Long, ByVal lpOverlapped As Long) As Long '//declare has changed
Public Declare Function SetFilePointer Lib "kernel32" (ByVal hFile As Long, ByVal lDistanceToMove As Long, lpDistanceToMoveHigh As Long, ByVal dwMoveMethod As Long) As Long

Public Declare Function CloseHandle Lib "kernel32" ( _
                         ByVal hObject As Long) As Long
                         
Public Declare Function CreateFile Lib "kernel32" _
                         Alias "CreateFileA" ( _
                         ByVal lpFileName As String, _
                         ByVal dwDesiredAccess As Long, _
                         ByVal dwShareMode As Long, _
                         ByRef lpSecurityAttributes As Any, _
                         ByVal dwCreationDisposition As Long, _
                         ByVal dwFlagsAndAttributes As Long, _
                         ByVal hTemplateFile As Long) As Long
                         
Public Declare Function DeviceIoControl Lib "kernel32" ( _
                         ByVal hDevice As Long, _
                         ByVal dwIoControlCode As Long, _
                         ByRef lpInBuffer As Any, _
                         ByVal nInBufferSize As Long, _
                         ByRef lpOutBuffer As Any, _
                         ByVal nOutBufferSize As Long, _
                         ByRef lpBytesReturned As Long, _
                         ByRef lpOverlapped As Any) As Long


Public Const GENERIC_READ = &H80000000
Public Const GENERIC_WRITE = &H40000000

Public Const FILE_SHARE_READ = &H1
Public Const FILE_SHARE_WRITE = &H2
Public Const OPEN_EXISTING = 3

Public Const INVALID_HANDLE_VALUE = -1
Public Const ERROR_SUCCESS = 0&


'ControlCodeConstant
Public Const IOCTL_VOLUME_GET_VOLUME_DISK_EXTENTS   As Long = &H560000
Public Const IOCTL_STORAGE_GET_DEVICE_NUMBER        As Long = &H2D1080



Public Declare Function FormatEx Lib "FMIFS.DLL" _
                       (DriveRoot As Any, _
                        ByVal MediaFlag As Long, _
                        Format As Any, _
                        Label As Any, _
                        ByVal QuickFormat As Long, _
                        ByVal ClusterSize As Long, _
                        ByVal Callback As Long) As Long

' MediaFlag
Public Const FMIFS_FLOPPY = &H8
Public Const FMIFS_REMOVABLE = &HB
Public Const FMIFS_HARDDISK = &HC

Public Enum FMIFS_MediaType
    HardDisk = FMIFS_HARDDISK
    Floppy = FMIFS_FLOPPY
    Removable = FMIFS_REMOVABLE
End Enum


' ClusterSize
Public Const FMIFS_SizeDefault = 0
Public Const FMIFS_Size512 = 512
Public Const FMIFS_Size1K = 1024
Public Const FMIFS_Size2K = 2048
Public Const FMIFS_Size4K = 4096
Public Const FMIFS_Size8K = 8192
Public Const FMIFS_Size16K = 16384
Public Const FMIFS_Size32K = 32768
Public Const FMIFS_Size64K = 65536
Public Const FMIFS_Size128K = 131072
Public Const FMIFS_Size256K = 262144

Public Enum ClusterSize
    Default = FMIFS_SizeDefault
    Size512 = FMIFS_Size512
    Size1K = FMIFS_Size1K
    Size2K = FMIFS_Size2K
    Size4K = FMIFS_Size4K
    Size8K = FMIFS_Size8K
    Size16K = FMIFS_Size16K
    Size32K = FMIFS_Size32K
    Size64K = FMIFS_Size64K
    Size128K = FMIFS_Size128K
    Size256K = FMIFS_Size256K
End Enum

' Command
Public Const FMIFS_Progress = 0
Public Const FMIFS_DoneWithStructure = 1
Public Const FMIFS_InsufficientRights = 6
Public Const FMIFS_WriteProtected = 7
Public Const FMIFS_Done = 11
Public Const FMIFS_OutPut = 14
Public Const FMIFS_StructureProgress = 15

Public Enum CallBackCommand
    cmdProgress = FMIFS_Progress
    cmdDoneWithStructure = FMIFS_DoneWithStructure
    cmdInsufficientRights = FMIFS_InsufficientRights
    cmdWriteProtected = FMIFS_WriteProtected
    cmdDone = FMIFS_Done
    cmdOutPut = FMIFS_OutPut
    cmdStructureProgress = FMIFS_StructureProgress
End Enum


Public Enum FileSystem
    NTFS = 0
    FAT = 1
    FAT32 = 2
    exFAT = 3
End Enum

Public Enum OperationType
    Normal = 0
    Silent = 1
End Enum




Public Enum QuickFormat
    FullFormat = 0
    QuickFormat = 1
End Enum

Public Const CB_PROGRESS As Long = 0
Public Const CB_FINISHED As Long = 11



Public Type FormatEx2Param
    nMajorVersion   As Long
    nFlags          As Long
    pVolumeLabel    As Long
    dwClusterSize   As Long
    nVersion        As Long
End Type

Public Const DRIVE_UNKNOWN      As Long = 0
Public Const DRIVE_NO_ROOT_DIR  As Long = 1
Public Const DRIVE_REMOVABLE    As Long = 2
Public Const DRIVE_FIXED        As Long = 3
Public Const DRIVE_REMOTE       As Long = 4
Public Const DRIVE_CDROM        As Long = 5
Public Const DRIVE_RAMDISK      As Long = 5



Public Type STORAGE_DEVICE_NUMBER
    DeviceType As Long
    DeviceNumber As Long
    PartitionNumber As Long
End Type



' C????True/False
Public Const API_TRUE = 1               ' VB? True ??-1
Public Const API_FALSE = 0              ' VB? False ??0

' ?????????
Public gbytResult   As Byte


Public AppObjPtr4 As Long   'DiskVolume
Public DiskVolume_hwnd As Long






Public Function FormatExCallBack(ByVal lngCommand As Long, ByVal lngSubAction As Long, ByVal ActionInfo As Long) As Long
    On Error GoTo ErrorHandler

    Dim objTemp As clsDiskVolume
    
    Call Win32.CopyMemory(objTemp, AppObjPtr4, 4)
    
    'Call GetMem4(AppObjPtr4,  VarPtr(objTemp))
    
    Call objTemp.Receive4(lngCommand, lngSubAction, ActionInfo)
    Call Win32.CopyMemory(objTemp, 0&, 4)
    FormatExCallBack = API_TRUE
    
    'DoEvents
    
Exit Function
ErrorHandler:
    Resume Next
End Function

