Attribute VB_Name = "mError"
Option Explicit

Private Const FORMAT_MESSAGE_ALLOCATE_BUFFER As Long = &H100
Private Const FORMAT_MESSAGE_FROM_SYSTEM As Long = &H1000


Private Const LANG_NEUTRAL = &H0
Private Const SUBLANG_DEFAULT = &H1
Private Const ERROR_BAD_USERNAME = 2202&

Private Declare Function GetLastError Lib "kernel32" () As Long
Private Declare Sub SetLastError Lib "kernel32" (ByVal dwErrCode As Long)
'Private Declare Function FormatMessage Lib "kernel32.dll" Alias "FormatMessageA" (ByVal dwFlags As Long, lpSource As Any, ByVal dwMessageId As Long, ByVal dwLanguageId As Long, ByVal lpBuffer As String, ByVal nSize As Long, Arguments As Long) As Long
Private Declare Function FormatMessage Lib "kernel32.dll" Alias "FormatMessageA" (ByVal dwFlags As Long, ByRef lpSource As Any, ByVal dwMessageId As Long, ByVal dwLanguageId As Long, ByVal lpBuffer As String, ByVal nSize As Long, ByRef Arguments As Long) As Long
Private Declare Function GetSystemDefaultLangID Lib "kernel32.dll" () As Integer

'SAMPLE
'MsgBox "DeviceIoControl() Error" & vbCrLf & vbCrLf & Err.LastDllError & " - " & GetError(Err.LastDllError), vbCritical



Public Function GetError(ByVal nErr As Long) As String
    Dim strBuf As String, nIns As Long

    strBuf = Space$(512)
    Call FormatMessage(FORMAT_MESSAGE_FROM_SYSTEM, 0, nErr, GetSystemDefaultLangID(), strBuf, 512, 0)

    nIns = InStr(1, strBuf, vbNullChar)
    If nIns Then
        GetError = Left(strBuf, nIns - 1)
    Else
        GetError = strBuf
    End If
End Function

Public Function mGetLastError() As String
    Dim Buffer As String
    'Create a string buffer
    Buffer = Space(200)
    'Set the error number
    
    'Format the message string
    FormatMessage FORMAT_MESSAGE_FROM_SYSTEM, ByVal 0&, GetLastError, LANG_NEUTRAL, Buffer, 200, ByVal 0&
    'Show the message
    mGetLastError = Buffer
End Function


